var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField } from 'vega-slimmer/core';
import { findParent } from '../../../../../utils/ui';
import { SubStateObserverSlimmer } from '../../../../../helpers/slimmers/sub-state/sub-state-observer-slimmer';
/**
 * Controller for the table head row
 */
export class VegaTableHeadRowStateController extends SubStateObserverSlimmer {
  // eslint-disable-next-line jsdoc/require-jsdoc
  constructor() {
    super({
      parent: 'vega-table',
      subStates: [
        {
          subStateName: 'expandable',
          parentStateName: 'rowExpandable',
        },
        {
          subStateName: 'paddingX',
          parentStateName: 'paddingX',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (value) => {
            const table = findParent(this.host, 'vega-table');
            if (table.dataSource.length === 0 || table.columns.length === 0) {
              this.paddingX = value;
            }
          },
        },
        {
          subStateName: 'selectionType',
          parentStateName: 'rowSelection',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (rowSelection) => {
            this.updateSelectionType(rowSelection);
          },
        },
        {
          subStateName: 'columnDivider',
          parentStateName: 'columnDivider',
        },
        {
          subStateName: 'density',
          parentStateName: 'density',
        },
        {
          subStateName: 'isTemplateRenderMode',
          parentStateName: 'isTemplateRenderMode',
        },
        {
          subStateName: 'isEmptyTable',
          parentStateName: 'currentData',
          // eslint-disable-next-line jsdoc/require-jsdoc
          callback: (currentData) => {
            this.isEmptyTable = currentData.length === 0;
          },
        },
      ],
    });
    /**
     * Update the selection config with the new config
     *
     * @param {VegaTableRowSelectionConfig} rowSelection - The updated row selection config.
     */
    this.updateSelectionType = (rowSelection) => {
      if (rowSelection) {
        const { type = 'multiple' } = rowSelection;
        this.selectionType = type;
      }
      else {
        this.selectionType = null;
      }
    };
  }
}
__decorate([
  MapToComponentField()
], VegaTableHeadRowStateController.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "expandable", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "selectionType", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "paddingX", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "columnDivider", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "density", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "isTemplateRenderMode", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaTableHeadRowStateController.prototype, "isEmptyTable", void 0);
